.586
.model FLAT, STDCALL
option casemap:none
option dotname

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\masm32.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\masm32.lib

; This include comes with Agner's randoma.zip file
includelib randomam.lib

MRandomInit			PROTO C :DWORD
MRandom				PROTO C
MIRandom			PROTO C :DWORD, :DWORD
MBRandom			PROTO C

.data

szFormat				db				"%s", 09h, 09h, "%d", 09h, 09h, "%u", 0Dh, 0Ah, 0

.data?

szVal                   db              200 dup (?)
dwCur					dd				?
fRl						REAL8			?
dwI						dd				?
dwU						dd				?

.code
start:

; Seed random num generator 
rdtsc
invoke MRandomInit, eax

; Setup loop
mov dwCur, 101
mloops:

; Get random integer between 0 and 100
invoke MIRandom, 0, 100
mov dwI, eax

; Get random bits
invoke MBRandom
mov dwU, eax

; Get random float
invoke MRandom
fstp fRl

; Display
invoke FloatToStr, fRl, addr szVal
invoke wsprintf, addr szVal, addr szFormat, addr szVal, dwI, dwU
invoke StdOut, addr szVal

; Loop
sub dwCur, 1
jnz mloops

; Exit
invoke ExitProcess, 0

end start